package cokr.xit.fims.mngt.dao;

import java.util.List;
import java.util.Map;

import org.egovframe.rte.psl.dataaccess.mapper.Mapper;

import cokr.xit.fims.cmmn.CmmnQuery;
import cokr.xit.fims.mngt.Task;
import cokr.xit.foundation.component.AbstractMapper;
import cokr.xit.foundation.data.DataObject;

/** 업무 정보 정보 DAO
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-10-24	JoJH 최초 작성
 * ================================
 * </pre>
 */
@Mapper("taskMapper")
public interface TaskMapper extends AbstractMapper {

	/**지정한 조건에 따라 업무 정보 목록을 조회하여 반환한다.<br />
	 * @param req 업무 정보 조회 조건
	 * @return 업무 정보 목록
	 */
	List<DataObject> selectTaskList(CmmnQuery req);

	/**지정한 조건에 따라 업무 정보 객체들을 반환한다.
	 * @param req 업무 정보 조회 조건
	 * @return 업무 정보 객체 목록
	 */
	List<DataObject> selectTasks(CmmnQuery req);

	/**지정한 조건에 따라 업무 정보 객체를 반환한다.
	 * @param req 업무 정보 조회 조건
	 * @return 업무 정보 객체
	 */
	default DataObject selectTaskInfo(CmmnQuery req) {
		// 사용 여부 확인
		if (req.getUseYn() == null) {
			req.setUseYn("Y");
		}

		List<DataObject> tasks = selectTasks(req);

		return !tasks.isEmpty() ? tasks.get(0) : null;
	}

	/**지정한 조건에 따라 사전통지 일자를 반환한다.
	 * @param req 업무 정보 조회 조건
	 * @return 업무 정보 객체
	 */
	DataObject selectAdvntceYmdInfo(CmmnQuery req);

	/**업무 정보 정보를 등록한다.
	 * @param params 파라미터
	 * <ul><li>"task" - 업무 정보</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int insertTask(Map<String, Object> params);

	/**업무 정보 정보를 등록한다.
	 * @param task 업무 정보
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean insert(Task task) {
		return task != null && insertTask(params().set("task", task)) == 1;
	}

	/**업무 정보 정보를 수정한다.
	 * @param params 파라미터
	 * <ul><li>"task" - 업무 정보</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int updateTask(Map<String, Object> params);

	/**업무 정보 정보를 수정한다.
	 * @param task 업무 정보
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean update(Task task) {
		return task != null && updateTask(params().set("task", task)) == 1;
	}

	/**지정한 업무 정보을 삭제한다.
	 * @param params 파라미터
	 * <ul><li>"task" - 업무 정보</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int deleteTask(Map<String, ?> params);

	/**업무 정보 정보를 삭제한다.
	 * @param task 업무 정보
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean delete(Task task) {
		return task != null && deleteTask(params().set("task", task)) == 1;
	}
}